<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: dlib::min_cut Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacedlib.html">dlib</a></li><li class="navelem"><a class="el" href="classdlib_1_1min__cut.html">min_cut</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pri-methods">Private Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a> &#124;
<a href="classdlib_1_1min__cut-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">dlib::min_cut Class Reference</div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:ae502b397bf2542233fd15f2f51ea1c65"><td class="memItemLeft" align="right" valign="top"><a id="ae502b397bf2542233fd15f2f51ea1c65"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>min_cut</b> (const <a class="el" href="classdlib_1_1min__cut.html">min_cut</a> &amp;)</td></tr>
<tr class="separator:ae502b397bf2542233fd15f2f51ea1c65"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a18b40a3ac8c71b9e95ad57b895e52089"><td class="memTemplParams" colspan="2"><a id="a18b40a3ac8c71b9e95ad57b895e52089"></a>
template&lt;typename directed_graph &gt; </td></tr>
<tr class="memitem:a18b40a3ac8c71b9e95ad57b895e52089"><td class="memTemplItemLeft" align="right" valign="top"><a class="el" href="structdlib_1_1enable__if.html">enable_if</a>&lt; <a class="el" href="structdlib_1_1is__directed__graph.html">is_directed_graph</a>&lt; <a class="el" href="classdlib_1_1directed__graph.html">directed_graph</a> &gt; &gt;::type&#160;</td><td class="memTemplItemRight" valign="bottom"><b>operator()</b> (<a class="el" href="classdlib_1_1directed__graph.html">directed_graph</a> &amp;g, const unsigned long source_node, const unsigned long sink_node) const</td></tr>
<tr class="separator:a18b40a3ac8c71b9e95ad57b895e52089"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0196f7637f0742b94e501300246cca9d"><td class="memTemplParams" colspan="2"><a id="a0196f7637f0742b94e501300246cca9d"></a>
template&lt;typename flow_graph &gt; </td></tr>
<tr class="memitem:a0196f7637f0742b94e501300246cca9d"><td class="memTemplItemLeft" align="right" valign="top"><a class="el" href="structdlib_1_1disable__if.html">disable_if</a>&lt; <a class="el" href="structdlib_1_1is__directed__graph.html">is_directed_graph</a>&lt; flow_graph &gt; &gt;::type&#160;</td><td class="memTemplItemRight" valign="bottom"><b>operator()</b> (flow_graph &amp;g, const unsigned long source_node, const unsigned long sink_node) const</td></tr>
<tr class="separator:a0196f7637f0742b94e501300246cca9d"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-methods"></a>
Private Member Functions</h2></td></tr>
<tr class="memitem:a2fcbeaae828f410fa27ee56034bedc4c"><td class="memItemLeft" align="right" valign="top"><a id="a2fcbeaae828f410fa27ee56034bedc4c"></a>
unsigned long&#160;</td><td class="memItemRight" valign="bottom"><b>distance_to_origin</b> (const unsigned long nil, unsigned long p, unsigned long) const</td></tr>
<tr class="separator:a2fcbeaae828f410fa27ee56034bedc4c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1efff044f941fe0cc17421af5349d32f"><td class="memTemplParams" colspan="2"><a id="a1efff044f941fe0cc17421af5349d32f"></a>
template&lt;typename flow_graph &gt; </td></tr>
<tr class="memitem:a1efff044f941fe0cc17421af5349d32f"><td class="memTemplItemLeft" align="right" valign="top">void&#160;</td><td class="memTemplItemRight" valign="bottom"><b>adopt</b> (flow_graph &amp;g, const unsigned long source, const unsigned long sink) const</td></tr>
<tr class="separator:a1efff044f941fe0cc17421af5349d32f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac8eb14a6325528f8cded7924f684497d"><td class="memTemplParams" colspan="2"><a id="ac8eb14a6325528f8cded7924f684497d"></a>
template&lt;typename flow_graph &gt; </td></tr>
<tr class="memitem:ac8eb14a6325528f8cded7924f684497d"><td class="memTemplItemLeft" align="right" valign="top">void&#160;</td><td class="memTemplItemRight" valign="bottom"><b>augment</b> (flow_graph &amp;g, const unsigned long &amp;source, const unsigned long &amp;sink, const unsigned long &amp;source_side, const unsigned long &amp;sink_side) const</td></tr>
<tr class="separator:ac8eb14a6325528f8cded7924f684497d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad01c572aad632297513b1fcfc0f96622"><td class="memTemplParams" colspan="2">template&lt;typename flow_graph &gt; </td></tr>
<tr class="memitem:ad01c572aad632297513b1fcfc0f96622"><td class="memTemplItemLeft" align="right" valign="top">bool&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classdlib_1_1min__cut.html#ad01c572aad632297513b1fcfc0f96622">grow</a> (flow_graph &amp;g, unsigned long &amp;source_side, unsigned long &amp;sink_side, typename flow_graph::in_edge_iterator &amp;in_begin, typename flow_graph::out_edge_iterator &amp;out_begin) const</td></tr>
<tr class="separator:ad01c572aad632297513b1fcfc0f96622"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac4ee964ee5f88f6b7691c32aa198f227"><td class="memItemLeft" align="right" valign="top"><a id="ac4ee964ee5f88f6b7691c32aa198f227"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>is_closer</b> (unsigned long p, unsigned long q) const</td></tr>
<tr class="separator:ac4ee964ee5f88f6b7691c32aa198f227"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr class="memitem:a50ea4614a3517f12f3da64dafa40692b"><td class="memItemLeft" align="right" valign="top"><a id="a50ea4614a3517f12f3da64dafa40692b"></a>
std::vector&lt; uint32 &gt;&#160;</td><td class="memItemRight" valign="bottom"><b>dist</b></td></tr>
<tr class="separator:a50ea4614a3517f12f3da64dafa40692b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a00b3a02652f1bd130cbab18edb9d8248"><td class="memItemLeft" align="right" valign="top"><a id="a00b3a02652f1bd130cbab18edb9d8248"></a>
std::vector&lt; uint32 &gt;&#160;</td><td class="memItemRight" valign="bottom"><b>ts</b></td></tr>
<tr class="separator:a00b3a02652f1bd130cbab18edb9d8248"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aff2088cd387f70b611eabad4aaee52b6"><td class="memItemLeft" align="right" valign="top"><a id="aff2088cd387f70b611eabad4aaee52b6"></a>
uint32&#160;</td><td class="memItemRight" valign="bottom"><b>time</b></td></tr>
<tr class="separator:aff2088cd387f70b611eabad4aaee52b6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a78b11a352e97b85e2da53ad148044121"><td class="memItemLeft" align="right" valign="top"><a id="a78b11a352e97b85e2da53ad148044121"></a>
std::vector&lt; unsigned long &gt;&#160;</td><td class="memItemRight" valign="bottom"><b>parent</b></td></tr>
<tr class="separator:a78b11a352e97b85e2da53ad148044121"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aac447b2ea245f69e80700fd19c1b40da"><td class="memItemLeft" align="right" valign="top"><a id="aac447b2ea245f69e80700fd19c1b40da"></a>
std::deque&lt; unsigned long &gt;&#160;</td><td class="memItemRight" valign="bottom"><b>active</b></td></tr>
<tr class="separator:aac447b2ea245f69e80700fd19c1b40da"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a20c8201352f24812d4159dd52da69400"><td class="memItemLeft" align="right" valign="top"><a id="a20c8201352f24812d4159dd52da69400"></a>
std::vector&lt; unsigned long &gt;&#160;</td><td class="memItemRight" valign="bottom"><b>orphans</b></td></tr>
<tr class="separator:a20c8201352f24812d4159dd52da69400"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="ad01c572aad632297513b1fcfc0f96622"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad01c572aad632297513b1fcfc0f96622">&#9670;&nbsp;</a></span>grow()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename flow_graph &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool dlib::min_cut::grow </td>
          <td>(</td>
          <td class="paramtype">flow_graph &amp;&#160;</td>
          <td class="paramname"><em>g</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned long &amp;&#160;</td>
          <td class="paramname"><em>source_side</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned long &amp;&#160;</td>
          <td class="paramname"><em>sink_side</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">typename flow_graph::in_edge_iterator &amp;&#160;</td>
          <td class="paramname"><em>in_begin</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">typename flow_graph::out_edge_iterator &amp;&#160;</td>
          <td class="paramname"><em>out_begin</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - if (an augmenting path was found) then 
        - returns true
        - (#source_side, #sink_side) == the point where the two trees meet.
          #source_side is part of the source tree and #sink_side is part of
          the sink tree.
    - else
        - returns false
</pre><p> ! </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="min__cut_8h_source.html">min_cut.h</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
